<template>
  <div v-if="currentEventId" class="overlay" @click.self="close">
    <transition name="fade">
      <div class="modal" :class="{'modal--active': modalShow}">
        <div class="review-label">Post a review</div>
        <form class="form" @submit="submit">
          <label class="star-rating-label" for="rating">Rating</label>
          <span class="star-rating">
            <StarRating :rating="rating" :edit-mode="true" starSize="17" @amount-change="setRating" />
          </span>
          <label class="text-label" for="text">Your comment</label>
          <textarea v-model="text" name="text" id="" cols="50" rows="8"></textarea>
          <div class="submit-btn" @click="submit">Submit</div>
        </form>
      </div>
    </transition>
  </div>
</template>
<script>
import StarRating from '@/components/events/StarRating'
import { EVENTS, MODAL, REVIEW } from '@/store/types'
import { mapGetters } from 'vuex'
export default {
  name: 'ReviewModal',
  components: {
    StarRating
  },
  data: () => ({
    modalShow: false,
    rating: 0, // max 5
    text: ''
  }),
  computed: {
    ...mapGetters({
      currentEventId: REVIEW.GETTER.GET_CURRENT_EVENT_ID
    })
  },
  watch: {
    currentEventId (id) {
      if (id) {
        setTimeout(() => (this.modalShow = true), 50)
      } else {
        this.modalShow = false
      }
    }
  },
  methods: {
    close (e) {
      this.$store.commit(REVIEW.MUTATION.SET_CURRENT_EVENT_ID, null)
      this.modalShow = false
      this.rating = 0
      this.text = ''
    },
    setRating (rating) {
      this.rating = Number(rating)
    },
    async submit () {
      const rating = Number(this.rating) + 1
      const text = this.text
      try {
        await this.$store.dispatch(REVIEW.ACTION.POST_REVIEW, { rating, text })
        this.$store.dispatch(EVENTS.ACTION.LOAD_REVIEWS_EVENTS, this.$route.params.id)
        this.close()
        setTimeout(() => {
          this.$store.commit(MODAL.MUTATION.SET_IS_MODAL_OPEN, true)
          this.$store.commit(MODAL.MUTATION.SET_MODAL_CONTENT, `Review successfully created!`)
          this.$store.commit(MODAL.MUTATION.SET_MODAL_ICON, 'success')
        }, 200)
      } catch (err) {
        this.close()
        setTimeout(() => {
          this.$store.commit(MODAL.MUTATION.SET_IS_MODAL_OPEN, true)
          this.$store.commit(MODAL.MUTATION.SET_MODAL_CONTENT, `Error while trying to create a review! ${err}`)
          this.$store.commit(MODAL.MUTATION.SET_MODAL_ICON, 'error')
        }, 200)
      }
    }
  }
}
</script>
<style lang="scss" scoped>
.overlay {
  width: 100%;
  height: 100%;
  position: fixed;
  top: 0;
  left: 0;
  z-index: 100;
  background: rgba(0,0,0,0.4);
  display: flex;
  justify-content: center;
  align-items: center;
}

.modal {
  background: white;
  border-radius: 5px;
  padding: 20px 20px;
  transition: 500ms;
  opacity: 0;

  &--active {
    opacity: 1;
  }
}

.submit-btn {
  color: white;
  background: #FF6392;
  padding: 10px 20px;
  margin-top: 20px;
}

.review-label {
  color: #FF6392;
  font-size: 28px;
  font-weight: bold;
  margin-bottom: 20px;
  text-align: start;
}

.form {
  display: flex;
  flex-direction: column;

  textarea {
    resize: none;
    padding: 5px;
    box-sizing: border-box;
  }

  label {
    width: 100%;
    text-align: start;
  }

  .star-rating-label {
    margin-bottom: 5px;
  }

  .star-rating {
    margin-bottom: 10px;
  }

  .text-label {
    margin-bottom: 5px;
  }
}
</style>
